(function($) {

    $.gamesRegistry('register', 'presentation', new (function() {

	this.options = {
	    view_width: Infinity,
	    view_height: Infinity,
	    view_background_img: undefined,
	    slides: [],
	};

	this.actualSlide = 1;
	this.total_slides = 0;

	this.clickEnable = true;

	this.has_clickable = [];

	this.clickable_ok_count = [];
	this.clickable_ok_click = 0;

	this.checkTask = function() {

	}

	//===============================================================================

	this.gotoSlide = function(slide_no) {

	    var self = this;

	    if (slide_no < 1 || slide_no > this.total_slides) {
		console.log('gotoSlide: Zly numer slajdu:' + slide_no);
		return;
	    }


	    self.clickEnable = false;

	    if (slide_no === 1) {
		$('.left, .right, .sound, .refresh').hide();
	    }
	    else {
		$('.start').hide();
	    }

	    self.clickable_ok_click = 0;

	    $('.right').hide();


	    $('#slide-' + self.actualSlide).fadeOut('slow', function() {


		$('#slide-' + slide_no).fadeIn('slow', function() {

		    $('.is_hidden').hide();
		    self.orgImage();

		    $('.isClicked').removeClass('isClicked');


		    if (slide_no === self.total_slides) {
			if (self.options.sound_end !== undefined && self.options.sound_end !== '' && SOUND_ON) {
			    if (snd_instance)
				snd_instance.stop();
			    snd_instance = null;
			    snd_instance = createjs.Sound.play(self.options.sound_end, createjs.Sound.INTERUPT_LATE);
			}
		    }

		    if (self.has_clickable[slide_no] === false && slide_no < self.total_slides && slide_no !== 1) {
			$('.right').fadeIn('slow');
		    }


		    if (slide_no > 1) {
			$('.left, .sound, .refresh').fadeIn('slow');
		    }
		    else {
			$('.start').show();
		    }

		    self.actualSlide = slide_no;

		    self.clickEnable = true;

		});
	    });

	}

	//===============================================================================

	this.nextSlide = function()
	{
	    if (this.actualSlide === this.total_slides) {
		console.log("nextSlide: aktualny slajd==ostatni slajd");
		return;
	    }
	    this.gotoSlide(this.actualSlide + 1);
	}

	//===============================================================================

	this.prevSlide = function()
	{
	    if (this.actualSlide <= 1) {
		console.log("prevSlide: aktualny slajd==1");
		return;
	    }
	    this.gotoSlide(this.actualSlide - 1);
	}

	//===============================================================================

	this.showEl = function(el)
	{
	    var self = this;
	    self.clickEnable = false;
	    var show_el = $(el).attr('show_el');
	    if (show_el !== undefined) {
		$('.is_hidden').hide();

		$('#' + show_el, $(el).parent()).fadeIn('slow', function() {

		    if (show_el === 'IMG_OK' || show_el === 'TEXT_OK') {

			$('.right').removeClass('animated rotateIn').addClass('animated rotateIn');

			$('.right').show();
			window.setTimeout(function() {
			    $('.right').removeClass('animated rotateIn');

			}, 1300);
		    }
		});
		return true;
	    }
	    return false;
	};

	//===============================================================================

	this.orgImage = function() {
	    $('.presentation-img').each(function(index, item) {

		var org_img = $(item).attr('org_image');
		if (org_img !== undefined && org_img !== '') {
		    $(item).css('background-image', 'url("' + org_img + '")');
		}
	    });
	};

	//===============================================================================	

	this.addObject = function(item, type, slide_no, obj_no, slide) 
	{
	    var self = this;
	    var hasClickableObj = false;

	    var div_item = $('<div class="presentation-elem presentation-' + type + '" id="' + type + '-' + slide_no + '-' + obj_no + '"></div>');

	    //obrazek
	    if (type === 'img') {

		var img = preload.getResult(item.image);

		if (img === undefined) {
		    console.log('addObject: Brak obrazka:' + item.image);
		}

		if (item.width === undefined) {
		    item.width = img.width;
		}
		if (item.height === undefined) {
		    item.height = img.height;
		}

		div_item.css('background-image', 'url("' + img.src + '")');

		if (item.scale !== undefined) {
		    this.width += (this.width * item.scale / 100);
		    this.height += (this.height * item.scale / 100);
		}

	    } else if (type === 'txt') {

		if (item.color !== undefined) {
		    div_item.css('color', item.color);
		}
		if (item.font !== undefined) {
		    div_item.css('font-family', item.font);
		}
		if (item.size !== undefined) {
		    div_item.css('font-size', item.size);
		}
		if (item.align !== undefined) {
		    div_item.css('text-align', item.align);
		}

		if (item.is_title !== undefined) {
		    document.title = item.text;
		}

		div_item.html(item.text);
	    } else {
		console.log("addObject: bledny typ:" + type);
		return;
	    }

	    //wspolne dane obiektu
	    if (item.show !== undefined && item.show !== '') {
		div_item.attr('show_el', item.show);
	    }

	    if (item.hidden !== undefined && item.hidden === true) {
		div_item.css('display', 'none');
	    }

	    if (item.class_name !== undefined) {
		div_item.addClass(item.class_name);
	    }

	    if (item.id !== undefined && item.id !== '') {
		div_item.attr('id', item.id);
		div_item.hide();
		div_item.addClass('is_hidden');
	    }

	    if (item.image_clicked) {
		var click_img = preload.getResult(item.image_clicked);

		div_item.attr('org_image', img.src);
		div_item.attr('click_image', click_img.src);
	    }

	    console.log(item);

	    if (item.title !== undefined && item.title !== '') {
		div_item.attr('title', item.title);
	    }


	    if (item.clickable)
	    {
		if (item.ok) {
		    if (self.clickable_ok_count[slide_no] === undefined) {
			self.clickable_ok_count[slide_no] = 1;
		    }
		    else {
			self.clickable_ok_count[slide_no]++;
		    }
		}


		div_item.css('cursor', 'pointer');

		hasClickableObj = true;


		div_item.click(function() {

		    if (self.clickEnable === false)
			return;
		    if (div_item.hasClass('isClicked') === true) {
			return;
		    }

		    if (self.clickable_ok_count[self.actualSlide] === self.clickable_ok_click) {
			return;
		    }


		    self.clickEnable = false;

		    if (item.ok === true)
		    {
			$('#refresh').hide();
			div_item.addClass('isClicked');

			var click_img = div_item.attr('click_image');
			if (click_img !== undefined && click_img !== '') {
			    div_item.css('background-image', 'url("' + click_img + '")');
			}

			self.clickable_ok_click++;

			if (self.options.sound_ok !== undefined && self.options.sound_ok !== '' && SOUND_ON) {
			    if (snd_instance)
				snd_instance.stop();
			    snd_instance = null;
			    snd_instance = createjs.Sound.play(self.options.sound_ok, createjs.Sound.INTERUPT_LATE);
			}

			div_item.removeClass('animated tada').addClass('animated tada');

			if (self.showEl(div_item))
			{
			    window.setTimeout(function() {
				div_item.removeClass('animated tada');
				self.clickEnable = true;
			    }, 1300);
			    return;
			}


			window.setTimeout(function() {

			    div_item.removeClass('animated tada');

			    if (self.clickable_ok_count[self.actualSlide] === self.clickable_ok_click)
			    {
				setTimeout(function() {
				    self.nextSlide();
				}, 1000);
			    }
			    else {
				self.clickEnable = true;
			    }

			}, 1300);

		    }
		    else
		    {
			if (self.options.sound_bad !== undefined && self.options.sound_bad !== '' && SOUND_ON) {
			    if (snd_instance)
				snd_instance.stop();
			    snd_instance = null;
			    snd_instance = createjs.Sound.play(self.options.sound_bad, createjs.Sound.INTERUPT_LATE);
			}

			div_item.removeClass('animated wobble').addClass('animated wobble');
			self.showEl(div_item);

			window.setTimeout(function() {
			    div_item.removeClass('animated wobble');
			    self.clickEnable = true;
			}, 1300
			    );

		    }
		});
	    }

	    var area = new absoluteArea(item);
	    area.applyAt(div_item, {
		view_width: self.options.view_width,
		view_height: self.options.view_height
	    });

	    slide.append(div_item);

	    return hasClickableObj;

	}

	//===============================================================================	


	this.init = function(data, endCallback) {

	    var self = this;

	    $.extend(this.options, data);


	    if (self.options.view_background_img !== undefined && self.options.view_background_img !== '')
	    {
		var background = preload.getResult(self.options.view_background_img).src;
		$('#playground').css('background-image', 'url("' + background + '")');
	    }


	    self.total_slides = Object.keys(self.options.slides).length;


	    var i = 1;
	    var slide_hasClickableElem = false;

	    $.each(self.options.slides, function(index, slide)
	    {

		slide_hasClickableElem = false;
		var slide_item = $('<div class="presentation-elem presentation-slide" style="display:none;" id="slide-' + i + '"></div>');

		//images
		var j = 1;
		$.each(slide.images, function(index, item)
		{
		    if (self.addObject(item, 'img', i, j, slide_item)) {
			slide_hasClickableElem = true;
		    }

		    j++;
		});

		//texts
		j = 1;
		$.each(slide.texts, function(index, item)
		{
		    if (self.addObject(item, 'txt', i, j, slide_item)) {
			slide_hasClickableElem = true;
		    }
		    j++;
		});

		self.has_clickable[i] = slide_hasClickableElem;

		i++;

		$('#playground').append(slide_item);
	    });


	    $('#slide-1').fadeIn('slow', function() {
		console.log('start game');
		$('.start').show();
	    });

	};
    })());

})(jQuery);